$(document).on('turbolinks:load', function() {
    if ($('body.admins-competitions-index-page').length > 0) {
        $('.modal.admin-upload-file-modal').on('upload:success', function(e, data){
            var $imageElement = $('.competition-image-' + data.source_id);
            $imageElement.attr('src', data.url);
            $imageElement.show();
            $imageElement.next().html('重新上传');
        });
    }

    $(".admin-competition-list-form").on("change", '.competitions-hot-select', function () {
        var s_value = $(this).get(0).checked ? 1 : 0;
        var json = {};
        json["hot"] = s_value;
        $.ajax({
            url: "/admins/competitions/hot_setting",
            type: "POST",
            dataType:'json',
            data: json,
            success: function(){
                $.notify({ message: '操作成功' });
            }
        });
    });

    // ============== 新增竞赛 ===============
    var $modal = $('.modal.admin-create-competition-modal');
    var $form = $modal.find('form.admin-create-competition-form');
    var $competitionNameInput = $form.find('input[name="competition_name"]');

    $form.validate({
        errorElement: 'span',
        errorClass: 'danger text-danger',
        rules: {
            competition_name: {
                required: true
            }
        }
    });

    // modal ready fire
    $modal.on('show.bs.modal', function () {
        $competitionNameInput.val('');
    });

    $modal.on('click', '.submit-btn', function(){
        $form.find('.error').html('');

        if ($form.valid()) {
            var url = $form.data('url');

            $.ajax({
                method: 'POST',
                dataType: 'json',
                url: url,
                data: $form.serialize(),
                success: function(){
                    $.notify({ message: '创建成功' });
                    $modal.modal('hide');

                    setTimeout(function(){
                        window.location.reload();
                    }, 500);
                },
                error: function(res){
                    var data = res.responseJSON;
                    $form.find('.error').html(data.message);
                }
            });
        }
    });
});

