class Oauth::BaseController < ActionController::Base
  include RenderHelper
  include LoginHelper
  include ControllerRescueHandler

  skip_before_action :verify_authenticity_token

  def auth_failure
    render_error(params[:message])
  end

  private

  def session_user_id
    session[:user_id]
  end

  def current_user
    @_current_user ||= User.find_by(id: session_user_id)
  end

  def auth_hash
    Rails.logger.info("[OAuth2] omniauth.auth -> #{request.env['omniauth.auth'].inspect}")
    request.env['omniauth.auth']
  end
end