class EcMajor < ApplicationRecord
  # 主页对应的学校，不同学校可以选用同样的专业，而每个专业又各具特色
  has_many :ec_major_schools, dependent: :destroy
  has_many :schools, through: :ec_major_schools

  # 一级专业
  belongs_to :ec_discipline_first

  scope :search_name_or_code, -> (keyword) { where('name LIKE :keyword OR code LIKE :keyword', keyword: "%#{keyword.strip}%") }
end
