require "rails_helper"

RSpec.describe EduSettingsController, type: :routing do
  describe "routing" do
    it "routes to #index" do
      expect(:get => "/edu_settings").to route_to("edu_settings#index")
    end

    it "routes to #new" do
      expect(:get => "/edu_settings/new").to route_to("edu_settings#new")
    end

    it "routes to #show" do
      expect(:get => "/edu_settings/1").to route_to("edu_settings#show", :id => "1")
    end

    it "routes to #edit" do
      expect(:get => "/edu_settings/1/edit").to route_to("edu_settings#edit", :id => "1")
    end


    it "routes to #create" do
      expect(:post => "/edu_settings").to route_to("edu_settings#create")
    end

    it "routes to #update via PUT" do
      expect(:put => "/edu_settings/1").to route_to("edu_settings#update", :id => "1")
    end

    it "routes to #update via PATCH" do
      expect(:patch => "/edu_settings/1").to route_to("edu_settings#update", :id => "1")
    end

    it "routes to #destroy" do
      expect(:delete => "/edu_settings/1").to route_to("edu_settings#destroy", :id => "1")
    end
  end
end
